## openfx-misc-natron-dmo 2.3.14

=== CMakeLists.txt ===
# ***** BEGIN LICENSE BLOCK *****
# This file is part of openfx-misc <https://github.com/devernay/openfx-misc>,
# Copyright (C) 2013-2018 INRIA
#
# openfx-misc is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# openfx-misc is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with openfx-misc.  If not, see <http://www.gnu.org/licenses/gpl-2.0.html>
# ***** END LICENSE BLOCK *****

########################################################################
IF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
MESSAGE(FATAL_ERROR "Prevented in-tree built. This is bad practice.")
ENDIF(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

########################################################################
# Project setup
########################################################################
CMAKE_MINIMUM_REQUIRED(VERSION 3.1)
PROJECT(OpenFXMisc CXX)
ENABLE_TESTING()

include(FindOpenGL REQUIRED)

set (CMAKE_CXX_STANDARD 11)

# Use -Ofast when applicable (implies -ffast-math)
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set (CMAKE_CXX_FLAGS_RELEASE "-Wall -Wextra -Ofast -DNDEBUG")
    set (CMAKE_C_FLAGS_RELEASE   "-Wall -Wextra -Ofast -DNDEBUG")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel")
    set (CMAKE_CXX_FLAGS_RELEASE "-Wall -Ofast -DNDEBUG")
    set (CMAKE_C_FLAGS_RELEASE   "-Wall -Ofast -DNDEBUG")
elseif("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set (CMAKE_CXX_FLAGS_RELEASE "-Wall -Wextra -Ofast -DNDEBUG")
    set (CMAKE_C_FLAGS_RELEASE   "-Wall -Wextra -Ofast -DNDEBUG")
endif()
SET(OPENFX_PATH ${CMAKE_CURRENT_SOURCE_DIR}/openfx)

# Check that submodule have been initialized and updated
if(NOT EXISTS ${PROJECT_SOURCE_DIR}/openfx/include)
  message(FATAL_ERROR
    "\n submodule(s) are missing, please update your repository:\n"
    "  > git submodule update -i\n")
endif()

# C++ Include directories
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SupportExt)
INCLUDE_DIRECTORIES(${OPENFX_PATH}/include)
INCLUDE_DIRECTORIES(${OPENFX_PATH}/Support/include)
INCLUDE_DIRECTORIES(${OPENFX_PATH}/Support/Plugins/include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/CImg)

# Define "DEBUG" on debug builds
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DDEBUG")

# /MP on MSVC
ADD_COMPILE_OPTIONS($<$<CXX_COMPILER_ID:MSVC>:/MP>)

SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DDEBUG")

set(OFX_SUPPORT_HEADER_DIR "${OPENFX_PATH}/Support/include")
set(OFX_SUPPORT_LIBRARY_DIR "${OPENFX_PATH}/Support/Library")

FILE(GLOB SUPPORT_SOURCES
    "${OFX_SUPPORT_HEADER_DIR}/*.h"

    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsCore.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsImageEffect.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsInteract.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsLog.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsMultiThread.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsParams.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsProperty.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/ofxsPropertyValidation.cpp"
    "${OFX_SUPPORT_LIBRARY_DIR}/*.h"
)

#ADD_LIBRARY(Support STATIC )
#TARGET_COMPILE_DEFINITIONS(Support PRIVATE OFX_SUPPORTS_OPENGLRENDER OFX_EXTENSIONS_TUTTLE OFX_EXTENSIONS_NUKE OFX_EXTENSIONS_NATRON OFX_EXTENSIONS_VEGAS NOMINMAX)

FILE(GLOB MISC_SOURCES
  "Add/*.cpp"
  "AdjustRoD/*.cpp"
  "Anaglyph/*.cpp"
  "AppendClip/*.cpp"
  "Card3D/*.cpp"
  "CheckerBoard/*.cpp"
  "ChromaKeyer/*.cpp"
  "Clamp/*.cpp"
  "ClipTest/*.cpp"
  "ColorBars/*.cpp"
  "ColorCorrect/*.cpp"
  "ColorLookup/*.cpp"
  "ColorMatrix/*.cpp"
  "ColorSuppress/*.cpp"
  "ColorTransform/*.cpp"
  "ColorWheel/*.cpp"
  "Constant/*.cpp"
  "ContactSheet/*.cpp"
  "CopyRectangle/*.cpp"
  "CornerPin/*.cpp"
  "Crop/*.cpp"
  "Deinterlace/*.cpp"
  "DenoiseSharpen/*.cpp"
  "Despill/*.cpp"
  "Difference/*.cpp"
  "Dissolve/*.cpp"
  "Distortion/*.cpp"
  "FrameBlend/*.cpp"
  "FrameHold/*.cpp"
  "FrameRange/*.cpp"
  "Gamma/*.cpp"
  "GodRays/*.cpp"
  "Grade/*.cpp"
  "HSVTool/*.cpp"
  "HueCorrect/*.cpp"
  "ImageStatistics/*.cpp"
  "Invert/*.cpp"
  "JoinViews/*.cpp"
  "KeyMix/*.cpp"
  "Keyer/*.cpp"
  "LayerContactSheet/*.cpp"
  "Log2Lin/*.cpp"
  "MatteMonitor/*.cpp"
  "Merge/*.cpp"
  "Mirror/*.cpp"
  "MixViews/*.cpp"
  "Multiply/*.cpp"
  "NoOp/*.cpp"
  "OneView/*.cpp"
  "PIK/*.cpp"
  "PLogLin/*.cpp"
  "Position/*.cpp"
  "Premult/*.cpp"
  "Quantize/*.cpp"
  "Radial/*.cpp"
  "Ramp/*.cpp"
  "Rand/*.cpp"
  "ReConverge/*.cpp"
  "Rectangle/*.cpp"
  "Reformat/*.cpp"
  "Retime/*.cpp"
  "Roto/*.cpp"
  "Saturation/*.cpp"
  "Shadertoy/*.cpp"
  "Shadertoy/*.h"
  "Shuffle/*.cpp"
  "SideBySide/*.cpp"
  "SlitScan/*.cpp"
  "SpriteSheet/*.cpp"
  "Switch/*.cpp"
  "Threshold/*.cpp"
  "TimeBlur/*.cpp"
  "TimeBuffer/*.cpp"
  "TimeDissolve/*.cpp"
  "TimeOffset/*.cpp"
  "TrackerPM/*.cpp"
  "Transform/*.cpp"
  "VectorToColor/*.cpp"
  "SupportExt/tinythread.cpp"
  "SupportExt/ofxsThreadSuite.cpp"
  "SupportExt/ofxsFileOpen.cpp"
  "SupportExt/ofxsGenerator.cpp"
  "SupportExt/ofxsLut.cpp"
  "SupportExt/ofxsMultiPlane.cpp"
  "SupportExt/ofxsOGLTextRenderer.cpp"
  "SupportExt/ofxsOGLFontData.cpp"
  "SupportExt/ofxsRamp.cpp"
  "SupportExt/ofxsShutter.cpp"
  "SupportExt/ofxsTracking.cpp"
  "SupportExt/ofxsTransform3x3.cpp"
  "SupportExt/ofxsTransformInteract.cpp"
  "SupportExt/ofxsRectangleInteract.cpp"
  "SupportExt/*.h"
)

FILE(GLOB MISC_RESOURCES
  "Add/net.sf.openfx.AddPlugin.png"
  "AdjustRoD/net.sf.openfx.AdjustRoDPlugin.png"
  "AdjustRoD/net.sf.openfx.AdjustRoDPlugin.svg"
  "Anaglyph/net.sf.openfx.anaglyphPlugin.png"
  "Anaglyph/net.sf.openfx.anaglyphPlugin.svg"
  "CheckerBoard/net.sf.openfx.CheckerBoardPlugin.png"
  "CheckerBoard/net.sf.openfx.CheckerBoardPlugin.svg"
  "ChromaKeyer/net.sf.openfx.ChromaKeyerPlugin.png"
  "ChromaKeyer/net.sf.openfx.ChromaKeyerPlugin.svg"
  "Clamp/net.sf.openfx.Clamp.png"
  "Clamp/net.sf.openfx.Clamp.svg"
  "ClipTest/net.sf.openfx.ClipTestPlugin.png"
  "ClipTest/net.sf.openfx.ClipTestPlugin.svg"
  "ColorBars/net.sf.openfx.ColorBars.png"
  "ColorBars/net.sf.openfx.ColorBars.svg"
  "ColorCorrect/net.sf.openfx.ColorCorrectPlugin.png"
  "ColorCorrect/net.sf.openfx.ColorCorrectPlugin.svg"
  "ColorLookup/net.sf.openfx.ColorLookupPlugin.png"
  "ColorLookup/net.sf.openfx.ColorLookupPlugin.svg"
  "ColorMatrix/net.sf.openfx.ColorMatrixPlugin.png"
  "ColorMatrix/net.sf.openfx.ColorMatrixPlugin.svg"
  "ColorWheel/net.sf.openfx.ColorWheel.png"
  "ColorWheel/net.sf.openfx.ColorWheel.svg"
  "ColorTransform/net.sf.openfx.HSVToRGB.png"
  "ColorTransform/net.sf.openfx.HSVToRGB.svg"
  "ColorTransform/net.sf.openfx.LabToRGB709.png"
  "ColorTransform/net.sf.openfx.RGBToHSV.png"
  "ColorTransform/net.sf.openfx.RGBToHSV.svg"
  "ColorTransform/net.sf.openfx.RGB709ToLab.png"
  "ColorTransform/net.sf.openfx.RGB709ToXYZ.png"
  "ColorTransform/net.sf.openfx.XYZToRGB709.png"
  "Constant/net.sf.openfx.ConstantPlugin.png"
  "Constant/net.sf.openfx.ConstantPlugin.svg"
  "CornerPin/net.sf.openfx.CornerPinMaskedPlugin.png"
  "CornerPin/net.sf.openfx.CornerPinMaskedPlugin.svg"
  "CornerPin/net.sf.openfx.CornerPinPlugin.png"
  "CornerPin/net.sf.openfx.CornerPinPlugin.svg"
  "Crop/net.sf.openfx.CropPlugin.png"
  "Crop/net.sf.openfx.CropPlugin.svg"
  "Deinterlace/net.sf.openfx.Deinterlace.png"
  "Deinterlace/net.sf.openfx.Deinterlace.svg"
  "Despill/net.sf.openfx.Despill.png"
  "Despill/net.sf.openfx.Despill.svg"
  "Difference/net.sf.openfx.DifferencePlugin.png"
  "Difference/net.sf.openfx.DifferencePlugin.svg"
  "Dissolve/net.sf.openfx.DissolvePlugin.png"
  "Dissolve/net.sf.openfx.DissolvePlugin.svg"
  "Distortion/net.sf.openfx.IDistort.png"
  "Distortion/net.sf.openfx.IDistort.svg"
  "Distortion/net.sf.openfx.STMap.png"
  "Distortion/net.sf.openfx.STMap.svg"
  "Distortion/net.sf.openfx.LensDistortion.png"
  "Distortion/net.sf.openfx.LensDistortion.svg"
  "FrameBlend/net.sf.openfx.FrameBlend.png"
  "FrameBlend/net.sf.openfx.FrameBlend.svg"
  "FrameHold/net.sf.openfx.FrameHold.png"
  "FrameHold/net.sf.openfx.FrameHold.svg"
  "FrameRange/net.sf.openfx.FrameRange.png"
  "FrameRange/net.sf.openfx.FrameRange.svg"
  "Gamma/net.sf.openfx.GammaPlugin.png"
  "GodRays/net.sf.openfx.GodRays.png"
  "GodRays/net.sf.openfx.GodRays.svg"
  "Grade/net.sf.openfx.GradePlugin.png"
  "Grade/net.sf.openfx.GradePlugin.svg"
  "HueCorrect/net.sf.openfx.HueCorrect.png"
  "HueCorrect/net.sf.openfx.HueCorrect.svg"
  "HueCorrect/net.sf.openfx.HueKeyer.png"
  "HueCorrect/net.sf.openfx.HueKeyer.svg"
  "HSVTool/net.sf.openfx.HSVToolPlugin.png"
  "HSVTool/net.sf.openfx.HSVToolPlugin.svg"
  "ImageStatistics/net.sf.openfx.ImageStatistics.png"
  "ImageStatistics/net.sf.openfx.ImageStatistics.svg"
  "Invert/net.sf.openfx.Invert.png"
  "Invert/net.sf.openfx.Invert.svg"
  "JoinViews/net.sf.openfx.joinViewsPlugin.png"
  "JoinViews/net.sf.openfx.joinViewsPlugin.svg"
  "Keyer/net.sf.openfx.KeyerPlugin.png"
  "Keyer/net.sf.openfx.KeyerPlugin.svg"
  "Merge/net.sf.openfx.MergePlugin.png"
  "Merge/net.sf.openfx.MergePlugin.svg"
  "Merge/net.sf.openfx.MergeDifference.png"
  "Merge/net.sf.openfx.MergeIn.png"
  "Merge/net.sf.openfx.MergeMax.png"
  "Merge/net.sf.openfx.MergeMin.png"
  "Merge/net.sf.openfx.MergeMultiply.png"
  "Merge/net.sf.openfx.MergeOut.png"
  "Merge/net.sf.openfx.MergePlus.png"
  "Merge/net.sf.openfx.MergeScreen.png"
  "Mirror/net.sf.openfx.Mirror.png"
  "Mirror/net.sf.openfx.Mirror.svg"
  "MixViews/net.sf.openfx.mixViewsPlugin.png"
  "MixViews/net.sf.openfx.mixViewsPlugin.svg"
  "Multiply/net.sf.openfx.MultiplyPlugin.png"
  "NoOp/net.sf.openfx.NoOpPlugin.png"
  "NoOp/net.sf.openfx.NoOpPlugin.svg"
  "Rand/net.sf.openfx.Noise.png"
  "Rand/net.sf.openfx.Noise.svg"
  "OneView/net.sf.openfx.oneViewPlugin.png"
  "OneView/net.sf.openfx.oneViewPlugin.svg"
  "PIK/net.sf.openfx.PIK.png"
  "PIK/net.sf.openfx.PIK.svg"
  "PIK/fr.inria.PIKColor.png"
  "PIK/fr.inria.PIKColor.svg"
  "PIK/PIKColor.gizmo"
  "PIK/PIKColor.py"
  "Position/net.sf.openfx.Position.png"
  "Position/net.sf.openfx.Position.svg"
  "Premult/net.sf.openfx.Premult.png"
  "Premult/net.sf.openfx.Premult.svg"
  "Premult/net.sf.openfx.Unpremult.png"
  "Premult/net.sf.openfx.Unpremult.svg"
  "Radial/net.sf.openfx.Radial.png"
  "Radial/net.sf.openfx.Radial.svg"
  "Ramp/net.sf.openfx.Ramp.png"
  "Ramp/net.sf.openfx.Ramp.svg"
  "Rectangle/net.sf.openfx.Rectangle.png"
  "Rectangle/net.sf.openfx.Rectangle.svg"
  "Reformat/net.sf.openfx.Reformat.png"
  "Reformat/net.sf.openfx.Reformat.svg"
  "Retime/net.sf.openfx.Retime.png"
  "Retime/net.sf.openfx.Retime.svg"
  "Roto/net.sf.openfx.RotoPlugin.png"
  "Roto/net.sf.openfx.RotoPlugin.svg"
  "Saturation/net.sf.openfx.SaturationPlugin.png"
  "Saturation/net.sf.openfx.SaturationPlugin.svg"
  "Shuffle/net.sf.openfx.ShufflePlugin.png"
  "Shuffle/net.sf.openfx.ShufflePlugin.svg"
  "SideBySide/net.sf.openfx.sideBySidePlugin.png"
  "SideBySide/net.sf.openfx.sideBySidePlugin.svg"
  "SlitScan/net.sf.openfx.SlitScan.png"
  "SlitScan/net.sf.openfx.SlitScan.svg"
  "Switch/net.sf.openfx.switchPlugin.png"
  "Switch/net.sf.openfx.switchPlugin.svg"
  "TimeOffset/net.sf.openfx.timeOffset.png"
  "TimeOffset/net.sf.openfx.timeOffset.svg"
  "TrackerPM/net.sf.openfx.TrackerPM.png"
  "TrackerPM/net.sf.openfx.TrackerPM.svg"
  "Transform/net.sf.openfx.DirBlur.png"
  "Transform/net.sf.openfx.DirBlur.svg"
  "Transform/net.sf.openfx.TransformMaskedPlugin.png"
  "Transform/net.sf.openfx.TransformMaskedPlugin.svg"
  "Transform/net.sf.openfx.TransformPlugin.png"
  "Transform/net.sf.openfx.TransformPlugin.svg"
  "VectorToColor/net.sf.openfx.VectorToColorPlugin.png"
  "VectorToColor/net.sf.openfx.VectorToColorPlugin.svg"
)

=== Makefile ===
SUBDIRS = Misc Shadertoy

SUBDIRS_NOMULTI = \
TimeBuffer \
Add \
AdjustRoD \
Anaglyph \
AppendClip \
Card3D \
CheckerBoard \
ChromaKeyer \
Clamp \
ClipTest \
ColorBars \
ColorCorrect \
ColorLookup \
ColorMatrix \
ColorSuppress \
ColorTransform \
ColorWheel \
Constant \
ContactSheet \
CopyRectangle \
CornerPin \
Crop \
Deinterlace \
DenoiseSharpen \
Despill \
Difference \
Dissolve \
FrameBlend \
FrameHold \
FrameRange \
Gamma \
GodRays \
Grade \
HSVTool \
HueCorrect \
Distortion \
ImageStatistics \
Invert \
JoinViews \
Keyer \
KeyMix \
LayerContactSheet \
Log2Lin \
MatteMonitor \
Merge \
Mirror \
Multiply \
MixViews \
NoOp \
OneView \
PIK \
PLogLin \
Position \
Premult \
Radial \
Ramp \
Rand \
ReConverge \
Rectangle \
Reformat \
Retime \
Roto \
Saturation \
Shuffle \
SideBySide \
SlitScan \
SpriteSheet \
Switch \
TimeBlur \
TimeDissolve \
TimeOffset \
TrackerPM \
Transform \
VectorToColor

ifeq ($(CONFIG),debug)
  # DebugProxy is only useful to debug the communication between a host and a plugin
  SUBDIRS += DebugProxy Test
endif

HAVE_CIMG ?= 1

# Build CImg-based plugins separately.
ifneq ($(HAVE_CIMG),0)
# add plugins which may use CImg here
  SUBDIRS += CImg
  SUBDIRS_NOMULTI += \
CImg/Bilateral \
CImg/Blur \
CImg/Denoise \
CImg/Equalize \
CImg/Erode \
CImg/ErodeSmooth \
CImg/Expression \
CImg/Guided \
CImg/HistEQ \
CImg/Median \
CImg/Noise \
CImg/Plasma \
CImg/RollingGuidance \
CImg/SharpenInvDiff \
CImg/SharpenShock \
CImg/Smooth \

endif

all: subdirs

.PHONY: nomulti subdirs clean install install-nomulti uninstall uninstall-nomulti $(SUBDIRS)

nomulti:
	$(MAKE) $(MFLAGS) SUBDIRS="$(SUBDIRS_NOMULTI)"

subdirs: $(SUBDIRS)

$(SUBDIRS):
	(cd $@ && $(MAKE) $(MFLAGS))

clean:
	@for i in $(SUBDIRS) $(SUBDIRS_NOMULTI); do \
	  echo "(cd $$i && $(MAKE) $(MFLAGS) $@)"; \
	  (cd $$i && $(MAKE) $(MFLAGS) $@); \
	done

install:
	@for i in $(SUBDIRS) ; do \
	  echo "(cd $$i && $(MAKE) $(MFLAGS) $@)"; \
	  (cd $$i && $(MAKE) $(MFLAGS) $@); \
	done

install-nomulti:
	$(MAKE) SUBDIRS="$(SUBDIRS_NOMULTI)" install

uninstall:
	@for i in $(SUBDIRS) ; do \
	  echo "(cd $$i && $(MAKE) $(MFLAGS) $@)"; \
	  (cd $$i && $(MAKE) $(MFLAGS) $@); \
	done

uninstall-nomulti:
	$(MAKE) $(MFLAGS) SUBDIRS="$(SUBDIRS_NOMULTI)" uninstall

=== AdjustRoD/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o AdjustRoD.o
PLUGINNAME = AdjustRoD
RESOURCES = net.sf.openfx.AdjustRoDPlugin.png net.sf.openfx.AdjustRoDPlugin.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== Anaglyph/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o Anaglyph.o
PLUGINNAME = Anaglyph
RESOURCES = net.sf.openfx.anaglyphPlugin.png net.sf.openfx.anaglyphPlugin.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== AppendClip/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o AppendClip.o
PLUGINNAME = AppendClip
#RESOURCES = net.sf.openfx.AppendClip.png net.sf.openfx.AppendClip.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== CImg/Makefile ===
# (ofxsLut required for ChromaBlur)
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o \
ofxsLut.o \
CImgBilateral.o \
CImgBlur.o \
CImgDenoise.o \
CImgDilate.o \
CImgDistance.o \
CImgEqualize.o \
CImgErode.o \
CImgErodeSmooth.o \
CImgExpression.o \
CImgGuided.o \
CImgHistEQ.o \
CImgInpaint-gpl.o \
CImgMatrix.o \
CImgMedian.o \
CImgNoise.o \
CImgPlasma.o \
CImgRollingGuidance.o \
CImgSharpenInvDiff.o \
CImgSharpenShock.o \
CImgSmooth.o \
CImgFilter.o \
CImgOperator.o \

# no ofxsInteract.o
SUPPORTOBJECTS = \
ofxsMultiThread.o \
ofxsProperty.o \
ofxsLog.o \
ofxsCore.o \
ofxsPropertyValidation.o \
ofxsImageEffect.o \
ofxsParams.o \

PLUGINNAME = CImg

# ls *png *.svg|sort |sed -e 's!$! \\!'
RESOURCES = \
Bilateral/net.sf.cimg.CImgBilateral.png \
Bilateral/net.sf.cimg.CImgBilateral.svg \
Blur/net.sf.cimg.CImgBlur.png \
Blur/net.sf.cimg.CImgBlur.svg \
Blur/net.sf.cimg.CImgChromaBlur.png \
Blur/net.sf.cimg.CImgChromaBlur.svg \
Blur/net.sf.cimg.CImgBloom.png \
Blur/net.sf.cimg.CImgBloom.svg \
Blur/eu.cimg.EdgeDetect.png \
Blur/eu.cimg.EdgeDetect.svg \
Blur/eu.cimg.EdgeExtend.png \
Blur/eu.cimg.EdgeExtend.svg \
Blur/fr.inria.EdgeBlur.png \
Blur/fr.inria.EdgeBlur.svg \
Blur/net.sf.cimg.CImgLaplacian.png \
Blur/net.sf.cimg.CImgLaplacian.svg \
Blur/net.sf.cimg.CImgSharpen.png \
Blur/net.sf.cimg.CImgSharpen.svg \
Denoise/net.sf.cimg.CImgDenoise.png \
Denoise/net.sf.cimg.CImgDenoise.svg \
Equalize/net.sf.cimg.CImgEqualize.png \
Equalize/net.sf.cimg.CImgEqualize.svg \
Erode/net.sf.cimg.CImgDilate.png \
Erode/net.sf.cimg.CImgDilate.svg \
Erode/net.sf.cimg.CImgErode.png \
Erode/net.sf.cimg.CImgErode.svg \
ErodeSmooth/net.sf.cimg.CImgErodeSmooth.png \
ErodeSmooth/net.sf.cimg.CImgErodeSmooth.svg \
Expression/net.sf.cimg.CImgExpression.png \
Expression/net.sf.cimg.CImgExpression.svg \
Guided/net.sf.cimg.CImgGuided.png \
Guided/net.sf.cimg.CImgGuided.svg \
HistEQ/net.sf.cimg.CImgHistEQ.png \
HistEQ/net.sf.cimg.CImgHistEQ.svg \
Inpaint/eu.cimg.Inpaint.png \
Inpaint/eu.cimg.Inpaint.svg \
Noise/net.sf.cimg.CImgNoise.png \
Noise/net.sf.cimg.CImgNoise.svg \
Plasma/net.sf.cimg.CImgPlasma.png \
Plasma/net.sf.cimg.CImgPlasma.svg \
RollingGuidance/net.sf.cimg.CImgRollingGuidance.png \
RollingGuidance/net.sf.cimg.CImgRollingGuidance.svg \
SharpenInvDiff/net.sf.cimg.CImgSharpenInvDiff.png \
SharpenInvDiff/net.sf.cimg.CImgSharpenInvDiff.svg \
SharpenShock/net.sf.cimg.CImgSharpenShock.png \
Smooth/net.sf.cimg.CImgSmooth.png \
Smooth/net.sf.cimg.CImgSmooth.svg \

VPATH += \
Bilateral \
Blur \
Denoise \
Distance \
Equalize \
Erode \
ErodeSmooth \
Expression \
Guided \
HistEQ \
Inpaint \
Matrix \
Median \
Noise \
Plasma \
RollingGuidance \
SharpenInvDiff \
SharpenShock \
Smooth \

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

CIMG_INCLUDE ?= /opt/local/include
CXXFLAGS += \
-I$(CIMG_INCLUDE) \
-I. \
-IBilateral \
-IBlur \
-IDenoise \
-IDistance \
-IEqualize \
-IErode \
-IErodeSmooth \
-IExpression \
-IGuided \
-IHistEQ \
-IInpaint \
-IMatrix \
-IMedian \
-INoise \
-IPlasma \
-IRollingGuidance \
-ISharpenInvDiff \
-ISharpenShock \
-ISmooth \

# openmp
ifeq ($(OPENMP),1)
  CXXFLAGS += -Dcimg_use_openmp -fopenmp
  LINKFLAGS += -fopenmp
endif

# For CImg.h versions,
# see https://github.com/dtschump/CImg/commits/master/CImg.h
#
# commit a841cc3080ee7bc00c5781e94b7f06c2920453ac is CImg 2.2.3+
# commit 4d54d452896fdf9347af68d3854f98f4986eea4c is CImg 2.3.1
# commit 548744b47c9316f656c4bdd1206e78646226c6be is CImg 2.3.3
CIMGVERSION=548744b47c9316f656c4bdd1206e78646226c6be

CImg.h: Inpaint/inpaint.h
	curl -L -s -S -o $@ https://raw.githubusercontent.com/dtschump/CImg/$(CIMGVERSION)/CImg.h
#	patch -p0 -d. < CImg-2.0.0-anisotropic.patch
#	patch -p0 -d. < CImg-1.7.1-omp.patch

Inpaint/inpaint.h:
	curl -L -s -S -o $@ https://raw.githubusercontent.com/dtschump/CImg/$(CIMGVERSION)/plugins/inpaint.h
	patch -p0 -d. < Inpaint/inpaint.h.patch

nlmeans.h:
	curl -L -s -S -o $@ https://raw.githubusercontent.com/dtschump/CImg/$(CIMGVERSION)/plugins/nlmeans.h

#git archive --remote=git://git.code.sf.net/p/gmic/source $(CIMGVERSION):src CImg.h | tar xf -

$(OBJECTPATH)/CImgBilateral.o: CImgBilateral.cpp CImgOperator.h CImgFilter.h CImg.h

$(OBJECTPATH)/CImgBlur.o: CImgBlur.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgDenoise.o: CImgDenoise.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgDistance.o: CImgDistance.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgEqualize.o: CImgEqualize.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgDilate.o: CImgDilate.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgErode.o: CImgErode.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgErodeSmooth.o: CImgErodeSmooth.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgExpression.o: CImgExpression.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgFilter.o: CImgOperator.cpp CImgOperator.h CImgFilter.h CImg.h

$(OBJECTPATH)/CImgGuided.o: CImgGuided.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgHistEQ.o: CImgHistEQ.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgInpaint-gpl.o: CImgInpaint-gpl.cpp CImgFilter.h CImg.h Inpaint/inpaint.h

$(OBJECTPATH)/CImgMatrix.o: CImgMatrix.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgMedian.o: CImgMedian.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgNoise.o: CImgNoise.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgOperator.o: CImgOperator.cpp CImgOperator.h CImgFilter.h CImg.h

$(OBJECTPATH)/CImgPlasma.o: CImgPlasma.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgRollingGuidance.o: CImgRollingGuidance.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgSharpenInvDiff.o: CImgSharpenInvDiff.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgSharpenShock.o: CImgSharpenShock.cpp CImgFilter.h CImg.h

$(OBJECTPATH)/CImgSmooth.o: CImgSmooth.cpp CImgFilter.h CImg.h

=== Card3D/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o ofxsTransform3x3.o ofxsShutter.o ofxsFileOpen.o Card3D.o
PLUGINNAME = Card3D
#RESOURCES =

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== CheckerBoard/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o CheckerBoard.o ofxsRectangleInteract.o ofxsGenerator.o
PLUGINNAME = CheckerBoard
RESOURCES = net.sf.openfx.CheckerBoardPlugin.png net.sf.openfx.CheckerBoardPlugin.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== ChromaKeyer/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o ChromaKeyer.o ofxsLut.o
PLUGINNAME = ChromaKeyer
RESOURCES = net.sf.openfx.ChromaKeyerPlugin.png net.sf.openfx.ChromaKeyerPlugin.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== Clamp/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o Clamp.o
PLUGINNAME = Clamp
RESOURCES = net.sf.openfx.Clamp.png net.sf.openfx.Clamp.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== ClipTest/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o ClipTest.o
PLUGINNAME = ClipTest
RESOURCES = net.sf.openfx.ClipTestPlugin.png net.sf.openfx.ClipTestPlugin.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== ColorBars/Makefile ===
PLUGINOBJECTS = ofxsThreadSuite.o tinythread.o ColorBars.o ofxsRectangleInteract.o ofxsGenerator.o ofxsLut.o
PLUGINNAME = ColorBars
RESOURCES = net.sf.openfx.ColorBars.png net.sf.openfx.ColorBars.svg

TOP_SRCDIR = ..
include $(TOP_SRCDIR)/Makefile.master

=== debian/changelog ===
openfx-misc-natron-dmo (2.3.14-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 16 Jul 2018 19:17:25 +0200

openfx-misc-natron-dmo (2.3.13-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 27 Jun 2018 15:53:47 +0200

openfx-misc-natron-dmo (2.3.12-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 24 May 2018 08:51:02 +0200

openfx-misc-natron-dmo (2.3.11-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 07 May 2018 13:02:58 +0200

openfx-misc-natron-dmo (2.3.8-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Mar 2018 08:34:48 +0100

openfx-misc-natron-dmo (2.3.7-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 16 Mar 2018 15:27:31 +0100

openfx-misc-natron-dmo (2.3.4-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 12 Dec 2017 01:37:53 +0100

openfx-misc-natron-dmo (2.3.3-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 09 Nov 2017 08:16:35 +0100

openfx-misc-natron-dmo (2.3.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 14 Aug 2017 09:14:23 +0200

openfx-misc-natron-dmo (2.3.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 26 Jul 2017 20:12:11 +0200

openfx-misc-natron-dmo (2.3.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 07 Jul 2017 15:46:15 +0200

=== debian/control ===
Source: openfx-misc-natron-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/NatronGitHub/openfx-misc
Standards-Version: 4.1.5
Build-Depends: debhelper (>= 11), libgl1-mesa-dev, quilt

Package: openfx-misc-natron
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Miscellaneous OFX / OpenFX / Open Effects plugins
 These plugins were primarily developed for Natron, but may be used with
 other OpenFX hosts.
 .
 See https://github.com/devernay/openfx-misc for a complete list of plugins.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(findstring parallel=,$(DEB_BUILD_OPTIONS)))
	NCPUS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NCPUS := $(shell getconf _NPROCESSORS_ONLN 2>/dev/null || echo 1)
	ifeq ($(NCPUS),-1)
		NCPUS:=1
	endif
	ifeq ($(NCPUS),0)
		NCPUS:=1
	endif
endif

%:
	dh $@ --with quilt

override_dh_auto_build:
# git clone https://github.com/NatronGitHub/openfx
# git clone https://github.com/NatronGitHub/openfx-supportext SupportExt
# find -name '.git*' | xargs rm -rf

	$(MAKE) -j $(NCPUS) CONFIG+=stable

override_dh_auto_install:
	$(MAKE) install CONFIG+=stable \
	DESTDIR=$(CURDIR)/debian/openfx-misc-natron

override_dh_clean:
	$(MAKE) clean CONFIG+=stable

	dh_clean CImg/CImg.h CImg/Inpaint/inpaint.h

	-rm -rf openfx/Documentation
	-rm -rf openfx/Examples
	-rm -rf openfx/website
	-rm -rf openfx/scripts
	-rm -rf openfx/Guide

	-rm -rf openfx/HostSupport/expat-2.2.1
	-rm -rf openfx/HostSupport/examples

	-rm -rf openfx/Support/PropTester

=== debian/watch ===
version=4

https://github.com/NatronGitHub/openfx-misc/releases \
(?:.*?/)?Natron-?(\d[\d.]*)\.tar\.gz
